#include "common.h"
#include "config_tar.h"

//=================
// TARʐݒ
//=================
LRESULT CConfigTAR::OnInitDialog(HWND hWnd, LPARAM lParam)
{
	// bZ[W[vɃbZ[WtB^ƃAChnhǉ
	CMessageLoop* pLoop = _Module.GetMessageLoop();
	pLoop->AddMessageFilter(this);

	//--------------------------------
	// GZIPkx̐ݒpXC_
	//--------------------------------
	Track_GZIP_Level=GetDlgItem(IDC_SLIDER_GZIP_COMPRESS_LEVEL);
	Track_GZIP_Level.SetRange(GZIP_COMPRESS_LEVEL_LOWEST,GZIP_COMPRESS_LEVEL_HIGHEST);
	Track_GZIP_Level.SetTicFreq(1);
	Track_GZIP_Level.SetPageSize(1);
	Track_GZIP_Level.SetLineSize(1);
	Track_GZIP_Level.SetPos(Config.TAR.GzipCompressLevel);

	//----------------------------------
	// GZIPkx̊mFpGfBbg
	//----------------------------------
	Edit_GZIP_Level=GetDlgItem(IDC_EDIT_GZIP_COMPRESS_LEVEL);
	CString Buffer;
	Buffer.Format(_T("%d"),Config.TAR.GzipCompressLevel);
	Edit_GZIP_Level.SetWindowText(Buffer);

	//---------------------------------
	// BZIP2kx̐ݒpXC_
	//---------------------------------
	Track_BZIP2_Level=GetDlgItem(IDC_SLIDER_BZIP2_COMPRESS_LEVEL);
	Track_BZIP2_Level.SetRange(BZIP2_COMPRESS_LEVEL_LOWEST,BZIP2_COMPRESS_LEVEL_HIGHEST);
	Track_BZIP2_Level.SetTicFreq(1);
	Track_BZIP2_Level.SetPageSize(1);
	Track_BZIP2_Level.SetLineSize(1);
	Track_BZIP2_Level.SetPos(Config.TAR.Bzip2CompressLevel);

	//-----------------------------------
	// BZIP2kx̊mFpGfBbg
	//-----------------------------------
	Edit_BZIP2_Level=GetDlgItem(IDC_EDIT_BZIP2_COMPRESS_LEVEL);
	Buffer.Format(_T("%d"),Config.TAR.Bzip2CompressLevel);
	Edit_BZIP2_Level.SetWindowText(Buffer);

	return TRUE;
}

LRESULT CConfigTAR::OnApply()
{
//===============================
// ݒConfigManagerɏ߂
//===============================
	//----------------
	// GZIPkx
	//----------------
	Config.TAR.GzipCompressLevel=Track_GZIP_Level.GetPos();

	//-----------------
	// BZIP2kx
	//-----------------
	Config.TAR.Bzip2CompressLevel=Track_BZIP2_Level.GetPos();
	return TRUE;
}


void CConfigTAR::OnHScroll(int, short, HWND)
{
	CString Buffer;
	Buffer.Format(_T("%d"),Track_GZIP_Level.GetPos());
	Edit_GZIP_Level.SetWindowText(Buffer);
	Buffer.Format(_T("%d"),Track_BZIP2_Level.GetPos());
	Edit_BZIP2_Level.SetWindowText(Buffer);
}

