#include "common.h"
#include "main.h"
//#include <mbctype.h>
#include "resource.h"
#include "ConfigCode/configwnd.h"
#include "compress.h"
#include "extract.h"
#include "TestArchive.h"
#include "ArchiverCode/arc_interface.h"
#include "FileListWindow/FileListFrame.h"
#include "ArchiverManager.h"
#include "Components/SelectDlg.h"
#include <locale.h>
#include "Components/ProgressDlg.h"

//EXEɃRg𖄂ߍł
//#pragma comment(exestr,_T("LhaForge by Claybird : This is an Archiver, using Common Archivers Library DLLs."))

CAppModule _Module;
CMessageLoop theLoop;


//---------------------------------------------

//Gg[|Cg
int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE, LPTSTR lpCmdLine, int nCmdShow)
{
#if defined(_DEBUG)
	// [Nop
	_CrtSetDbgFlag(
		_CRTDBG_ALLOC_MEM_DF
		| _CRTDBG_LEAK_CHECK_DF
		);
#endif
	_tsetlocale(LC_ALL,_T(""));	//P[ϐ擾

	HRESULT hRes = ::CoInitialize(NULL);
	ATLASSERT(SUCCEEDED(hRes));
	OleInitialize(NULL);
	// Microsoft Layer for Unicode (MSLU) gpꂽ
	// ATLEChE thunking 
	::DefWindowProc(NULL, 0, 0, 0L);

	// ̃Rg[T|[g邽߂̃tOǉ
	AtlInitCommonControls(ICC_WIN95_CLASSES|ICC_COOL_CLASSES | ICC_BAR_CLASSES);
	_Module.Init(NULL,hInstance);
	_Module.AddMessageLoop(&theLoop);

	//*********************************
	// R}hCp[^̉
	//*********************************
	/*
	IvVw`:

	/b2e		B2E32.dllgp
	/c:???		???`Ŏw肳ꂽt@Ck(???=lzh,zip,etc...)
	/method:???	???\bhgĈk(B2Ê)
	/b2esfx		ȉ𓀌`ňk(B2Ê)
	/e			t@C
	/o:[dir]	o͐fBNgw
	/l			A[JCut@C̃Xg\(P)
	/f:[file]	ko̓t@C̎w(pXw͖)
	/xacrett	XacRett.DLLIɎgp(/{)
	/!			/xacrettƓ
	/m			t@C𓀂̓Xg\(ݒɂύX)
	/s			t@CEtH_k
	/t			A[JCut@C̊SeXg
	/@[file]	X|Xt@Cw
	/$[file]	X|Xt@Cw:X|Xt@C͓ǂݎ芮폜

	*/

	bool bCheckUpdate=true;	//LFCaldixNȂtrue

	CMDLINEINFO CommandLineInfo;

	CConfigManager Config;
	PROCESS_MODE ProcessMode=ParseCommandLine(Config,CommandLineInfo);
	CArchiverDLLManager::GetInstance().SetConfigManager(Config);
	Config.LoadConfig(CONFIG_B2E);

	//DLLCXg[擾%PATH%ɒǉ
	Config.LoadConfig(CONFIG_UPDATE);
	{
		//---Vϐ
		CString strPath(Config.Update.szDLLPath);
		if(!strPath.IsEmpty()){
			strPath+=_T(";");

			//---ϐ擾
			int len=GetEnvironmentVariable(_T("PATH"),NULL,0);
			CString strEnv;
			GetEnvironmentVariable(_T("PATH"),strEnv.GetBuffer(len+1),len);
			strEnv.ReleaseBuffer();

			strPath+=strEnv;
			SetEnvironmentVariable(_T("PATH"),strPath);
		}
	}

	switch(ProcessMode){
	case PROCESS_COMPRESS://k
		DoCompress(Config,CommandLineInfo);
		break;
	case PROCESS_EXTRACT://
		DoExtract(Config,CommandLineInfo);
		break;
	case PROCESS_AUTOMATIC://C
		if(PathIsDirectory(*CommandLineInfo.FileList.begin())){
			DoCompress(Config,CommandLineInfo);
		}
		else{
			Config.LoadConfig(CONFIG_XACRETT);
			if(CArchiverDLLManager::GetInstance().GetArchiver(*CommandLineInfo.FileList.begin(),CommandLineInfo.idForceDLL)){	//𓀉\Ȍ`ǂ
				DoExtract(Config,CommandLineInfo);
			}
			else{
				DoCompress(Config,CommandLineInfo);
			}
		}
		break;
	case PROCESS_LIST://Xg\
		DoList(Config,CommandLineInfo);
		break;
	case PROCESS_TEST://A[JCut@C̃eXg
		DoTest(CommandLineInfo);
		break;
	case PROCESS_CONFIGURE://ݒʕ\
		{
			bCheckUpdate=false;
			Config.LoadConfig(CONFIG_UPDATE);
			if(Config.Update.AskUpdate){
				UtilAskAndCheckUpdate(Config);
			}
			CConfigDialog confdlg(Config);
			if(IDOK==confdlg.DoModal())Config.SaveConfig(CONFIG_LOAD_ALL);
		}
		break;
	case PROCESS_INVALID:
		TRACE(_T("Process Mode Undefined\n"));
		break;
	default:
		ASSERT(!"Unexpected Process Mode");
	}
	//Abvf[g`FbN
	if(bCheckUpdate){
//		Config.LoadConfig(CONFIG_UPDATE);
		if(Config.Update.AskUpdate){
			UtilAskAndCheckUpdate(Config);
		}
	}

	TRACE(_T("Terminating...\n"));
	CArchiverDLLManager::GetInstance().Final();
//	Sleep(1);	//ΏǗÖ@ for 0xC0000005: Access Violation
	_Module.RemoveMessageLoop();
	_Module.Term();
	OleUninitialize();
	::CoUninitialize();
	TRACE(_T("Exit main()\n"));
	return 0;
}

bool DoCompress(CConfigManager &Config,CMDLINEINFO &CommandLineInfo)
{
	Config.LoadConfig(CONFIG_COMMON);
	//B2E֘A
	CString strB2EFormat;
	CString strB2EMethod;

	if(CommandLineInfo.idForceDLL==DLL_ID_B2E){
		CommandLineInfo.CompressType=PARAMETER_B2E;
	}

	while(PARAMETER_UNDEFINED==CommandLineInfo.CompressType||PARAMETER_B2E==CommandLineInfo.CompressType){	//---gpDLL
		if(PARAMETER_UNDEFINED==CommandLineInfo.CompressType){	//`w肳ĂȂꍇ
			if(Config.Common.Compress.UseDefaultParameter){	//ftHgp[^gȂf[^擾
				CommandLineInfo.CompressType=Config.Common.Compress.DefaultType;
				CommandLineInfo.Options=Config.Common.Compress.DefaultOptions;

				if(CommandLineInfo.CompressType==PARAMETER_B2E){	//B2Egpꍇ
					CommandLineInfo.idForceDLL=DLL_ID_B2E;	//B2E32.dll̎gp𖾎
					//p[^w
					CommandLineInfo.B2EInfo.bSFX=BOOL2bool(CommandLineInfo.Options);	//ȉ
					CommandLineInfo.B2EInfo.strFormat=Config.Common.Compress.DefaultB2EFormat;	//`
					CommandLineInfo.B2EInfo.strMethod=Config.Common.Compress.DefaultB2EMethod;	//\bh
				}
			}else{	//͂𑣂
				CSelectDialog SelDlg;
				CommandLineInfo.CompressType=(PARAMETER_TYPE)SelDlg.DoModal();
				if(PARAMETER_UNDEFINED==CommandLineInfo.CompressType){	//LZ̏ꍇ
					return false;
				}else if(CommandLineInfo.CompressType!=PARAMETER_B2E){
					CommandLineInfo.idForceDLL=DLL_ID_UNKNOWN;

					CommandLineInfo.Options=SelDlg.GetOptions();
					CommandLineInfo.bSingleCompression=SelDlg.IsSingleCompression();
					break;
				}
			}
		}
		if(CommandLineInfo.CompressType==PARAMETER_B2E){	//B2Egpꍇ
			//---B2E32.dll̃`FbN
			CArchiverB2E &B2EHandler=CArchiverDLLManager::GetInstance().GetB2EHandler();
			if(!B2EHandler.IsOK()){
				CommandLineInfo.CompressType=PARAMETER_UNDEFINED;
				CString msg;
				msg.Format(IDS_ERROR_DLL_LOAD,B2EHandler.GetName());
				ErrorMessage(msg);
				continue;
//				return false;
			}

			//---`I
			if(CommandLineInfo.B2EInfo.strFormat.IsEmpty()){
				CB2ESelectDialog SelDlg;
				INT_PTR Ret=SelDlg.DoModal();
				if(IDCANCEL==Ret){	//LZ̏ꍇ
					return false;
				}else if(IDC_COMPRESS_USENORMAL==Ret){	//ʏDLLg
					CommandLineInfo.CompressType=PARAMETER_UNDEFINED;
				}else{
					CommandLineInfo.idForceDLL=DLL_ID_B2E;

					CommandLineInfo.Options=0;
					CommandLineInfo.B2EInfo.bSFX=SelDlg.IsSFX();
					CommandLineInfo.bSingleCompression=SelDlg.IsSingleCompression();
					strB2EFormat=SelDlg.GetFormat();
					strB2EMethod=SelDlg.GetMethod();
					break;
				}
			}else{
				strB2EFormat=CommandLineInfo.B2EInfo.strFormat;
				strB2EMethod=CommandLineInfo.B2EInfo.strMethod;
				break;
			}
		}
	}

	//--------------------
	// k

	if(CommandLineInfo.bSingleCompression){	//t@Ck
		//vOXo[
		CProgressDialog dlg;
		int nFiles=CommandLineInfo.FileList.size();
		if(nFiles>=2){	//t@C鎞Ɍ
			dlg.Create(NULL);
			dlg.SetTotalFileCount(nFiles);
			dlg.ShowWindow(SW_SHOW);
		}
		bool bRet=true;
		for(std::list<CString>::iterator ite=CommandLineInfo.FileList.begin();ite!=CommandLineInfo.FileList.end();ite++){
			//vOXo[i߂
			if(dlg.IsWindow())dlg.SetNextState(*ite);

			//k
			std::list<CString> TempList;
			TempList.push_back(*ite);

			if(CommandLineInfo.idForceDLL==DLL_ID_B2E){	//B2Eg
				bRet=bRet&&B2ECompress(TempList,Config,CommandLineInfo.OutputFileName,CommandLineInfo.OutputDir,strB2EFormat,strB2EMethod,CommandLineInfo.B2EInfo.bSFX);
			}
			else{
				bRet=bRet&&Compress(TempList,CommandLineInfo.CompressType,Config,CommandLineInfo.Options,CommandLineInfo.OutputFileName,CommandLineInfo.OutputDir);
			}
		}
		//vOXo[
		if(dlg.IsWindow())dlg.DestroyWindow();
		return bRet;
	}
	else{	//ʏ툳k
		if(CommandLineInfo.idForceDLL==DLL_ID_B2E){	//B2Eg
			return B2ECompress(CommandLineInfo.FileList,Config,CommandLineInfo.OutputFileName,CommandLineInfo.OutputDir,strB2EFormat,strB2EMethod,CommandLineInfo.B2EInfo.bSFX);
		}
		else{
			return Compress(CommandLineInfo.FileList,CommandLineInfo.CompressType,Config,CommandLineInfo.Options,CommandLineInfo.OutputFileName,CommandLineInfo.OutputDir);
		}
	}
}

bool DoExtract(CConfigManager &Config,CMDLINEINFO &CommandLineInfo)
{
	MakeListFilesOnly(CommandLineInfo.FileList,CommandLineInfo.idForceDLL,true);
	if(CommandLineInfo.FileList.empty()){
		ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_FILE_NOT_SPECIFIED)));
		return false;
	}
	return Extract(CommandLineInfo.FileList,Config,CommandLineInfo.idForceDLL,CommandLineInfo.OutputDir);
}

bool DoList(CConfigManager &Config,CMDLINEINFO &CommandLineInfo)
{
	MakeListFilesOnly(CommandLineInfo.FileList,CommandLineInfo.idForceDLL,true);
	//t@CXgɉcȂG[bZ[W\
	if(CommandLineInfo.FileList.empty()){
		ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_FILE_NOT_SPECIFIED)));
		return false;
	}

//==========
// {Jn
//==========
	std::list<CString>::iterator ite=CommandLineInfo.FileList.begin();
	const std::list<CString>::iterator End=CommandLineInfo.FileList.end();

	//----------------------------
	// t@C̏d{֎~
	//----------------------------

	/*CreateMutex:lpName
	~[ebNXIuWFNg̖O NULL ŏI镶ւ̃|C^w肵܂B
	Oɂ́u \ vȊO̔Cӂ̕gpł܂B
	啶͋ʂ܂Bő啶 MAX_PATH łB
	*/
	CString MutexName(*ite);
	MutexName.MakeLower();	//ɓ
	MutexName.Replace(_T('\\'),_T('/'));

	//~[ebNX쐬
	bool bAbort=false;	//trueȂ{ɂ̃vZXI
	CreateMutex(NULL, TRUE, MutexName);
	if(ERROR_ALREADY_EXISTS==GetLastError()){
		//łɉ{Ăꍇ
		bAbort=true;
	}

	//ŏ̃t@Ĉ͎ŁA2ڈȍ~n
	ite++;
	//قɕ\t@Cw肳ĂAgdN\
	if(ite!=End){
		TCHAR ExePath[_MAX_PATH+1];
		FILL_ZERO(ExePath);
		GetModuleFileName(GetModuleHandle(NULL),ExePath,_MAX_PATH);

		CString Param;
		for(;ite!=End;ite++){
			//t@C𕡐nꂽ玩g𕡐NAꂼɃXg\
			Param=_T("/l ");
			if(CommandLineInfo.idForceDLL==DLL_ID_XACRETT){
				Param+=_T("/! ");
			}else if(CommandLineInfo.idForceDLL==DLL_ID_B2E){
				Param+=_T("/b2e ");
			}
			Param+=_T("\"");
			Param+=*ite;
			Param+=_T("\"");
			ShellExecute(NULL,NULL,ExePath,Param,NULL,SW_RESTORE);
		}
	}

	//łɓt@C{Ăꍇ
	//̃t@C\ĂEBhE
	if(bAbort){
		EnumWindows(EnumFileListWindowProc,(LPARAM)(LPCTSTR)MutexName);
		return false;
	}

	CFileListFrame ListWindow(Config,MutexName,CommandLineInfo.idForceDLL);
	ListWindow.CreateEx();
	ListWindow.ShowWindow(SW_SHOW);
	ListWindow.UpdateWindow();
	ListWindow.SetArchiveFile(*CommandLineInfo.FileList.begin());

	theLoop.Run();

	return true;
}

//A[JCũeXg
bool DoTest(CMDLINEINFO &CommandLineInfo)
{
	//SẴt@CΏۂɂ
	MakeListFilesOnly(CommandLineInfo.FileList,CommandLineInfo.idForceDLL,false);
	//t@CXgɉcȂG[bZ[W\
	if(CommandLineInfo.FileList.empty()){
		ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_FILE_NOT_SPECIFIED)));
		return false;
	}

	//eXg
	return TestArchive(CommandLineInfo.FileList);
}

//R}hC߂t@C̏@肷
PROCESS_MODE ParseCommandLine(CConfigManager &Config,CMDLINEINFO &CommandLineInfo)
{
	std::vector<CString> ParamsArray;
	int nArgc=UtilGetCommandLineParams(ParamsArray);
#if defined(_DEBUG)
	//For Debug
	MessageBox(NULL,GetCommandLine(),_T("CommandLine"),MB_OK|MB_ICONINFORMATION);
	TRACE(_T("---Command Parameter Dump---\n"));
	for(int i=0;i<nArgc;i++)
	{
		TRACE(_T("ParamsArray[%d]=%s\n"),i,ParamsArray[i]);
	}
	TRACE(_T("---End Dump---\n\n"));
#endif

/*	if(nArgc<2){
		//s
		return PROCESS_CONFIGURE;
	}
	else if(2==nArgc&&0==_tcsncmp(_T("/"),ParamsArray[1],1)){	//IvVĂȂ
		return PROCESS_CONFIGURE;	//ݒʕ\
	}
*/
	const bool bPressedShift=GetKeyState(VK_SHIFT)<0;	//SHIFTĂ邩ǂ
	const bool bPressedControl=GetKeyState(VK_CONTROL)<0;	//CONTROLĂ邩ǂ
	PROCESS_MODE ProcessMode=PROCESS_AUTOMATIC;

	UTIL_CODEPAGE uCodePage=UTILCP_SJIS;	//X|Xt@C̃R[hy[Ww

	for(int iIndex=1;iIndex<nArgc;iIndex++){
		if(0!=_tcsncmp(_T("/"),ParamsArray[iIndex],1)){//IvVł͂Ȃ
			//t@CƂ݂ȂAΏۃt@C̃Xgɋlߍ
			//ȉ̓t@C̏
			if(0>=_tcslen(ParamsArray[iIndex])){	//NULLȂ疳
				continue;
			}
			CommandLineInfo.FileList.push_back(ParamsArray[iIndex]);
		}
		else{
			//------------------
			// IvV̉
			//------------------
			CString Parameter(ParamsArray[iIndex]);
			//ɕϊ
			Parameter.MakeLower();
			if(0==_tcsncmp(_T("/cfg"),Parameter,4)){//ݒt@Cw
				if(0==_tcsncmp(_T("/cfg:"),Parameter,5)){
					//o̓t@C̐؂o;̎_""͊OĂ
					CommandLineInfo.ConfigPath=(LPCTSTR)Parameter+5;
				}
				else if(_T("/cfg")==Parameter){
					CommandLineInfo.ConfigPath.Empty();
				}
				else{
					CString msg;
					msg.Format(IDS_ERROR_INVALID_PARAMETER,ParamsArray[iIndex]);
					ErrorMessage(msg);
					return PROCESS_INVALID;
				}
				//ݒt@C̎w肪L΃Zbg;΃ftHgɖ߂
				if(CommandLineInfo.ConfigPath.IsEmpty()){
					Config.SetConfigFile(NULL);
				}else{
					Config.SetConfigFile(CommandLineInfo.ConfigPath);
				}
				TRACE(_T("ConfigPath=%s\n"),CommandLineInfo.ConfigPath);
			}
			else if(0==_tcsncmp(_T("/cp"),Parameter,3)){//X|Xt@C̃R[hy[Ww
				if(0==_tcsncmp(_T("/cp:"),Parameter,4)){
					CString cp((LPCTSTR)Parameter+4);
					cp.MakeLower();
					if(cp==_T("utf8")||cp==_T("utf-8")){
						uCodePage=UTILCP_UTF8;
					}else if(cp==_T("utf16")||cp==_T("utf-16")||cp==_T("unicode")){
						uCodePage=UTILCP_UTF16;
					}else if(cp==_T("sjis")||cp==_T("shiftjis")||cp==_T("s-jis")||cp==_T("s_jis")){
						uCodePage=UTILCP_SJIS;
					}else{
						CString msg;
						msg.Format(IDS_ERROR_INVALID_PARAMETER,(LPCTSTR)ParamsArray[iIndex]+4);
						ErrorMessage(msg);
						return PROCESS_INVALID;
					}
				}
				else if(_T("/cp")==Parameter){
					uCodePage=UTILCP_SJIS;	//ftHgɖ߂
				}
				else{
					CString msg;
					msg.Format(IDS_ERROR_INVALID_PARAMETER,ParamsArray[iIndex]);
					ErrorMessage(msg);
					return PROCESS_INVALID;
				}
			}
			else if(0==_tcsncmp(_T("/c"),Parameter,2)){//kwĂ
				ProcessMode=PROCESS_COMPRESS;
				//----------------
				// k`̉
				//----------------
				if(_T("/c")==Parameter){	//`w肳ĂȂꍇ
					CommandLineInfo.CompressType=PARAMETER_UNDEFINED;
				}
				else if(0!=_tcsncmp(_T("/c:"),Parameter,3)){
					CString msg;
					msg.Format(IDS_ERROR_INVALID_PARAMETER,ParamsArray[iIndex]);
					ErrorMessage(msg);
					return PROCESS_INVALID;
				}
				else if(DLL_ID_B2E==CommandLineInfo.idForceDLL){	//B2Eňkꍇ
					//k̂ݐ؂肾
					CommandLineInfo.B2EInfo.strFormat=(LPCTSTR)Parameter+3;
				}
				else{
					CommandLineInfo.CompressType=PARAMETER_UNDEFINED;
					//R}hCp[^ƌ`̑Ή\T
					for(int i=0;i<COMPRESS_PARAM_COUNT;i++){
						if(CompressParameterArray[i].Param==Parameter){
							CommandLineInfo.CompressType=CompressParameterArray[i].Type;
							CommandLineInfo.Options=CompressParameterArray[i].Options;
							break;
						}
					}
					if(PARAMETER_UNDEFINED==CommandLineInfo.CompressType){
						CString msg;
						msg.Format(IDS_ERROR_INVALID_COMPRESS_PARAMETER,Parameter);
						ErrorMessage(msg);
						return PROCESS_INVALID;
					}

					//CONTROLL[ĂȂAʈk
					if(bPressedControl){
						CommandLineInfo.bSingleCompression=true;
					}
				}
			}
			else if(_T("/e")==Parameter){//𓀂wĂ
				if(bPressedShift){
					ProcessMode=PROCESS_LIST;	//SHIFTL[Ă{[h
				}else if(bPressedControl){
					ProcessMode=PROCESS_TEST;	//CTRLL[Ă猟[h
				}else{
					ProcessMode=PROCESS_EXTRACT;
				}
			}
			else if(_T("/l")==Parameter){//t@Cꗗ\
				ProcessMode=PROCESS_LIST;
			}
			else if(_T("/t")==Parameter){//A[JCueXg
				ProcessMode=PROCESS_TEST;
			}
			else if(_T("/m")==Parameter){//@I
				Config.LoadConfig(CONFIG_OPENACTION);
				OPENACTION OpenAction;
				if(bPressedShift){	//---Shift
					OpenAction=Config.OpenAction.OpenAction_Shift;
				}else if(bPressedControl){	//---Ctrl
					OpenAction=Config.OpenAction.OpenAction_Ctrl;
				}else{	//---ʏ펞
					OpenAction=Config.OpenAction.OpenAction;
				}
				switch(OpenAction){
				case OPENACTION_EXTRACT://
					ProcessMode=PROCESS_EXTRACT;
					break;
				case OPENACTION_LIST:	//{
					ProcessMode=PROCESS_LIST;
					break;
				case OPENACTION_TEST:	//
					ProcessMode=PROCESS_TEST;
					break;
				case OPENACTION_ASK:	//mF
					ProcessMode=SelectOpenAction();
					if(ProcessMode==PROCESS_INVALID){
						return PROCESS_INVALID;
					}
					break;
				default:
					ASSERT(!"This code must not be run");
					return PROCESS_INVALID;
				}
			}
			else if(_T("/!")==Parameter||_T("/xacrett")==Parameter){//XacRett.DLLgp
				CommandLineInfo.idForceDLL=DLL_ID_XACRETT;
			}
			else if(_T("/b2e")==Parameter){//B2E32.dllgp
				CommandLineInfo.idForceDLL=DLL_ID_B2E;
			}
			else if(_T("/b2esfx")==Parameter){//B2E32.dllgpĎȉ𓀂Ɉk
				CommandLineInfo.B2EInfo.bSFX=true;
			}
			else if(_T("/s")==Parameter){//t@Ck
				CommandLineInfo.bSingleCompression=true;
			}
			else if(0==_tcsncmp(_T("/o"),Parameter,2)){//o͐tH_w
				if(0==_tcsncmp(_T("/o:"),Parameter,3)){
					//o͐tH_̐؂o;̎_""͊OĂ
					CommandLineInfo.OutputDir=(LPCTSTR)Parameter+3;
				}
				else if(_T("/o")==Parameter){
					CommandLineInfo.OutputDir.Empty();
				}
				else{
					CString msg;
					msg.Format(IDS_ERROR_INVALID_PARAMETER,ParamsArray[iIndex]);
					ErrorMessage(msg);
					return PROCESS_INVALID;
				}
				TRACE(_T("OutputDir=%s\n"),CommandLineInfo.OutputDir);
			}
			else if(0==_tcsncmp(_T("/@"),Parameter,2)&&Parameter.GetLength()>2){//X|Xt@Cw
				CString strFile;
				if(PATHERROR_NONE!=UtilGetCompletePathName(strFile,(LPCTSTR)Parameter+2)||
					!UtilReadFromResponceFile(strFile,uCodePage,CommandLineInfo.FileList)){
					//ǂݍݎs
					ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_READ_RESPONCEFILE)));
					return PROCESS_INVALID;
				}
			}
			else if(0==_tcsncmp(_T("/$"),Parameter,2)&&Parameter.GetLength()>2){//X|Xt@Cw(ǂݎ폜)
				CString strFile;
				if(PATHERROR_NONE!=UtilGetCompletePathName(strFile,(LPCTSTR)Parameter+2)||
					!UtilReadFromResponceFile(strFile,uCodePage,CommandLineInfo.FileList)){
					//ǂݍݎs
					ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_READ_RESPONCEFILE)));
					return PROCESS_INVALID;
				}
				else DeleteFile(strFile);	//폜
			}
			else if(0==_tcsncmp(_T("/f"),Parameter,2)){//o̓t@Cw
				if(0==_tcsncmp(_T("/f:"),Parameter,3)){
					//o̓t@C̐؂o;̎_""͊OĂ
					CommandLineInfo.OutputFileName=(LPCTSTR)Parameter+3;
				}
				else if(_T("/f")==Parameter){
					CommandLineInfo.OutputFileName.Empty();
				}
				else{
					CString msg;
					msg.Format(IDS_ERROR_INVALID_PARAMETER,ParamsArray[iIndex]);
					ErrorMessage(msg);
					return PROCESS_INVALID;
				}
				TRACE(_T("OutputFileName=%s\n"),CommandLineInfo.OutputFileName);
			}
			else if(0==_tcsncmp(_T("/method:"),Parameter,8)){//k\bhw
				CommandLineInfo.B2EInfo.strMethod=(LPCTSTR)Parameter+8;
			}
			else{	//m̃IvV
				CString msg;
				msg.Format(IDS_ERROR_INVALID_PARAMETER,ParamsArray[iIndex]);
				ErrorMessage(msg);
				return PROCESS_INVALID;
			}
		}
	}
	if(CommandLineInfo.FileList.empty()){
		//XCb`݂̂w肳Ăꍇɂ͐ݒʂ\
		//------
		// ݂Ȃt@Cw肳Ăꍇɂ̓G[ԂĂ̂ŁA
		// Ńt@CXgł΃t@Cw肳ĂȂƔfłB
		return PROCESS_CONFIGURE;
	}else{
		//ChJ[h̓WJ
		UtilPathExpandWild(CommandLineInfo.FileList,CommandLineInfo.FileList);
	}
	//---t@C̃tpXȂǃ`FbN
	for(std::list<CString>::iterator ite=CommandLineInfo.FileList.begin();ite!=CommandLineInfo.FileList.end();ite++){
		CPath strAbsPath;
		switch(UtilGetCompletePathName(strAbsPath,*ite)){
		case PATHERROR_NONE:
			//
			break;
		case PATHERROR_INVALID:
			//p[^w肪s
			ASSERT(!"p[^w肪s");
			return PROCESS_INVALID;
		case PATHERROR_ABSPATH:
			//΃pX̎擾Ɏs
			ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_FAIL_GET_ABSPATH)));
			return PROCESS_INVALID;
		case PATHERROR_NOTFOUND:
			//t@C̓tH_݂Ȃ
			{
				CString msg;
				msg.Format(IDS_ERROR_FILE_NOT_FOUND,*ite);
				ErrorMessage(msg);
			}
			return PROCESS_INVALID;
		case PATHERROR_LONGNAME:
			//Ot@C擾s
			ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_FAIL_GET_LONGNAME)));
			return PROCESS_INVALID;
		}

		//pX̍Ōオ\ŏIĂ\菜
		strAbsPath.RemoveBackslash();
		TRACE(strAbsPath),TRACE(_T("\n"));

		//lXV
		*ite=(CString)strAbsPath;
	}
	//o̓tH_w肳ĂA΃pXɕϊ
	if(!CommandLineInfo.OutputDir.IsEmpty()){
		if(!UtilGetAbsPathName(CommandLineInfo.OutputDir,CommandLineInfo.OutputDir)){
			//΃pX̎擾Ɏs
			ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_FAIL_GET_ABSPATH)));
			return PROCESS_INVALID;
		}
	}

	return ProcessMode;
}

BOOL CALLBACK EnumFileListWindowProc(HWND hWnd,LPARAM lParam)
{
	TCHAR Buffer[_MAX_PATH+1];
	FILL_ZERO(Buffer);
	GetClassName(hWnd,Buffer,_MAX_PATH);
	if(0!=_tcsncmp(LHAFORGE_FILE_LIST_CLASS,Buffer,_MAX_PATH)){
		return TRUE;
	}
	if(GetProp(hWnd,(LPCTSTR)lParam)){
		ShowWindow(hWnd,SW_RESTORE);
		SetForegroundWindow(hWnd);
		FLASHWINFO fi;
		FILL_ZERO(fi);
		fi.dwFlags=FLASHW_ALL;
		fi.hwnd=hWnd;
		fi.cbSize=sizeof(fi);
		fi.uCount=3;
		FlashWindowEx(&fi);
		return FALSE;
	}
	return TRUE;
}

//JI
PROCESS_MODE SelectOpenAction()
{
	COpenActionDialog Dialog;
	switch(Dialog.DoModal()){
	case IDC_BUTTON_OPENACTION_EXTRACT:
		return PROCESS_EXTRACT;
	case IDC_BUTTON_OPENACTION_LIST:
		return PROCESS_LIST;
	case IDC_BUTTON_OPENACTION_TEST:
		return PROCESS_TEST;
	default:
		return PROCESS_INVALID;
	}
}


//XgtH_폜ATutH_̃t@Cǉ
void MakeListFilesOnly(std::list<CString> &FileList,DLL_ID idForceDLL,bool bArchivesOnly)
{
	std::list<CString>::iterator ite;
	for(ite=FileList.begin();ite!=FileList.end();){
		if(PathIsDirectory(*ite)){
			//---𓀑ΏۂtH_ȂċA𓀂
			std::list<CString> subFileList;
			UtilRecursiveEnumFile(*ite,subFileList);

			for(std::list<CString>::iterator ite2=subFileList.begin();ite2!=subFileList.end();ite2++){
				if(!bArchivesOnly||CArchiverDLLManager::GetInstance().GetArchiver(*ite2,idForceDLL)){
					//ΉĂ`̂ݒǉKv鎞́A𓀉\Ȍ`ǂ肷
					FileList.push_back(*ite2);
				}
			}
			//͍폜
			ite=FileList.erase(ite);
		}
		else{
			ite++;
		}
	}
}
