#pragma once
#include "arc_interface.h"

typedef BOOL   (WINAPI *COMMON_ARCHIVER_SETUNICODEMODE)(BOOL);
typedef int    (WINAPI *COMMON_ARCHIVER_GETARCHIVETYPE)(LPCSTR);

class CArchiver7ZIP:public CArchiverDLL{
protected:
	void WriteResponceFile(HANDLE,LPCTSTR);
	COMMON_ARCHIVER_SETUNICODEMODE ArchiverSetUnicodeMode;
	COMMON_ARCHIVER_GETARCHIVETYPE ArchiverGetArchiveType;
public:
	CArchiver7ZIP();
	virtual ~CArchiver7ZIP();
	virtual LOAD_RESULT LoadDLL(CConfigManager &Config,bool bSilent);
	virtual void FreeDLL();
	virtual bool IsUnicodeCapable(){return true;}	//UNICODEΉDLLȂtrueԂ
	virtual bool Compress(LPCTSTR,std::list<CString>&,CConfigManager&,const PARAMETER_TYPE,int,CString &);
	virtual bool Extract(LPCTSTR,CConfigManager&,bool,LPCTSTR,CString &);
	virtual bool ExtractSpecifiedOnly(LPCTSTR ArcFileName,LPCTSTR OutputDir,std::list<CString>&,CString &,bool bUsePath=false);
	virtual bool QueryFastExtractSpecifiedOnlySupported(){return true;}	//ExtractSpecifiedOnlyT|[gĂȂtrue
	virtual bool ExamineArchive(LPCTSTR,bool,bool&,bool&,CString&);

	//A[JCut@C폜
	virtual bool DeleteFileFromArchive(LPCTSTR ArcFileName,std::list<CString>&,CString &);
	virtual bool QueryDeleteFileFromArchiveSupported(){return true;}		//DeleteFileT|[gĂ邩ǂ

	virtual ARCRESULT TestArchive(LPCTSTR,CString &);	//A[JCuǂ`FbN

	//A[JCuɎw肵t@Cǉ
	virtual bool AddFileToArchive(LPCTSTR ArcFileName,std::list<CString>&,CConfigManager&,LPCTSTR lpDestDir,CString&);
	virtual bool QueryAddFileToArchiveSupported(){return true;}

	//-------------------------------
	//---UNICODEłI[o[Ch---
	//-------------------------------
	virtual BOOL CheckArchive(LPCTSTR);
	virtual int GetFileCount(LPCTSTR);	//A[JCũt@CԂ

	// ɓp\bh
	virtual bool InspectArchiveBegin(LPCTSTR);				//ɓJn
	virtual bool InspectArchiveGetFileName(CString&);		//ɓt@C擾
	virtual bool InspectArchiveGetMethodString(CString&);			//ɓt@Ci[[h擾
};

