#pragma once
#include "arc_interface.h"
#include "../resource.h"

typedef BOOL (CALLBACK *COMMON_ARCHIVER_PROC)(HWND,UINT,UINT,LPVOID);

typedef BOOL (WINAPI *COMMON_ARCHIVER_SETOWNERWINDOWEX)(HWND,COMMON_ARCHIVER_PROC);
typedef BOOL (WINAPI *COMMON_ARCHIVER_KILLOWNERWINDOWEX)(HWND);

typedef struct{
	DWORD	dwFileSize;		//i[t@C̃TCY
	DWORD	dwWriteSize;	//WJŏ񂾃TCY
	char	szSourceFileName[FNAME_MAX32 + 1];	//si[t@C
	char	dummy1[3];
	char	szDestFileName[FNAME_MAX32 + 1];	//ۂɏ܂pX
	char	dummy[3];
}EXTRACTINGINFO,*LPEXTRACTINGINFO;


class CArchiverTAR:public CArchiverDLL{
protected:
//	void WriteResponceFile(HANDLE,LPCTSTR);
	static BOOL CALLBACK ArchiverProc(HWND,UINT,UINT,LPVOID);	//㏑mFpR[obN
	static bool bForceOverwrite;		//㏑ǂ

	COMMON_ARCHIVER_SETOWNERWINDOWEX	ArchiverSetOwnerWindowEx;
	COMMON_ARCHIVER_KILLOWNERWINDOWEX	ArchiverKillOwnerWindowEx;
public:
	CArchiverTAR();
	virtual ~CArchiverTAR();
	virtual LOAD_RESULT LoadDLL(CConfigManager&,bool bSilent=false);
	virtual void FreeDLL();
	virtual bool Compress(LPCTSTR,std::list<CString>&,CConfigManager&,const PARAMETER_TYPE,int,CString &);
	virtual bool Extract(LPCTSTR,CConfigManager&,bool,LPCTSTR,CString &);
	virtual bool ExtractSpecifiedOnly(LPCTSTR ArcFileName,LPCTSTR OutputDir,std::list<CString>&,CString &,bool bUsePath=false);
	virtual bool ExamineArchive(LPCTSTR,bool,bool&,bool&,CString&);
	virtual void PreExtractSpecifiedOnly();
};



//㏑mF_CAO
class CConfirmOverwriteDialog : public CDialogImpl<CConfirmOverwriteDialog>
{
protected:
	CEdit Edit_MessageArea;
public:
	enum {IDD = IDD_DIALOG_CONFIRM_OVERWRITE};
	CString			DiskFileName;
	FILETIME		DiskFileTime;
	ULARGE_INTEGER	DiskFileSize;

	DWORD			ExtractFileSize;

	// bZ[W}bv
	BEGIN_MSG_MAP_EX(CConfirmOverwriteDialog)
		MSG_WM_INITDIALOG(OnInitDialog)
		COMMAND_ID_HANDLER_EX(IDC_BUTTON_EXTRACT_CONTINUE, OnButton)
		COMMAND_ID_HANDLER_EX(IDC_BUTTON_EXTRACT_OVERWRITE_ALL, OnButton)
		COMMAND_ID_HANDLER_EX(IDC_BUTTON_EXTRACT_ABORT, OnButton)
	END_MSG_MAP()

	void OnButton(UINT uNotifyCode, int nID, HWND hWndCtl){
		EndDialog(nID);
	}
	LRESULT OnInitDialog(HWND hWnd, LPARAM lParam);
};

