#include "common.h"
#include "config_bga.h"

//=================
// BGAʐݒ
//=================
LRESULT CConfigBGA::OnInitDialog(HWND hWnd, LPARAM lParam)
{
	// bZ[W[vɃbZ[WtB^ƃAChnhǉ
	CMessageLoop* pLoop = _Module.GetMessageLoop();
	pLoop->AddMessageFilter(this);

	//--------------------------------
	// GZAkx̐ݒpXC_
	//--------------------------------
	Track_GZA_Level=GetDlgItem(IDC_SLIDER_GZA_COMPRESS_LEVEL);
	Track_GZA_Level.SetRange(GZA_COMPRESS_LEVEL_LOWEST,GZA_COMPRESS_LEVEL_HIGHEST);
	Track_GZA_Level.SetTicFreq(1);
	Track_GZA_Level.SetPageSize(1);
	Track_GZA_Level.SetLineSize(1);
	Track_GZA_Level.SetPos(Config.BGA.GZALevel);

	//----------------------------------
	// GZAkx̊mFpGfBbg
	//----------------------------------
	Edit_GZA_Level=GetDlgItem(IDC_EDIT_GZA_COMPRESS_LEVEL);
	CString Buffer;
	Buffer.Format(_T("%d"),Config.BGA.GZALevel);
	Edit_GZA_Level.SetWindowText(Buffer);

	//---------------------------------
	// BZAkx̐ݒpXC_
	//---------------------------------
	Track_BZA_Level=GetDlgItem(IDC_SLIDER_BZA_COMPRESS_LEVEL);
	Track_BZA_Level.SetRange(BZA_COMPRESS_LEVEL_LOWEST,BZA_COMPRESS_LEVEL_HIGHEST);
	Track_BZA_Level.SetTicFreq(1);
	Track_BZA_Level.SetPageSize(1);
	Track_BZA_Level.SetLineSize(1);
	Track_BZA_Level.SetPos(Config.BGA.BZALevel);

	//-----------------------------------
	// BZAkx̊mFpGfBbg
	//-----------------------------------
	Edit_BZA_Level=GetDlgItem(IDC_EDIT_BZA_COMPRESS_LEVEL);
	Buffer.Format(_T("%d"),Config.BGA.BZALevel);
	Edit_BZA_Level.SetWindowText(Buffer);

	return TRUE;
}

LRESULT CConfigBGA::OnApply()
{
//===============================
// ݒConfigManagerɏ߂
//===============================
	//----------------
	// GZAkx
	//----------------
	Config.BGA.GZALevel=Track_GZA_Level.GetPos();

	//-----------------
	// BZAkx
	//-----------------
	Config.BGA.BZALevel=Track_BZA_Level.GetPos();
	return TRUE;
}


void CConfigBGA::OnHScroll(int, short, HWND)
{
	CString Buffer;
	Buffer.Format(_T("%d"),Track_GZA_Level.GetPos());
	Edit_GZA_Level.SetWindowText(Buffer);
	Buffer.Format(_T("%d"),Track_BZA_Level.GetPos());
	Edit_BZA_Level.SetWindowText(Buffer);
}

