#include "common.h"
#include "config_HKI.h"

//=================
// HKIʐݒ
//=================
LRESULT CConfigHKI::OnInitDialog(HWND hWnd, LPARAM lParam)
{
	// bZ[W[vɃbZ[WtB^ƃAChnhǉ
	CMessageLoop* pLoop = _Module.GetMessageLoop();
	pLoop->AddMessageFilter(this);

	//------------------
	// kx̑I
	//------------------
	Radio_CompressLevel[HKI_COMPRESS_LEVEL_NONE]=GetDlgItem(IDC_RADIO_HKI_LV0);
	Radio_CompressLevel[HKI_COMPRESS_LEVEL_FAST]=GetDlgItem(IDC_RADIO_HKI_LV1);
	Radio_CompressLevel[HKI_COMPRESS_LEVEL_NORMAL]=GetDlgItem(IDC_RADIO_HKI_LV2);
	Radio_CompressLevel[HKI_COMPRESS_LEVEL_HIGH]=GetDlgItem(IDC_RADIO_HKI_LV3);

	Radio_CompressLevel[Config.HKI.CompressLevel].SetCheck(1);

	//--------------------------
	// ÍASY̑I
	//--------------------------
	Radio_EncryptAlgorithm[HKI_ENCRYPT_NONE]=GetDlgItem(IDC_RADIO_HKI_ENCRYPT0);
	Radio_EncryptAlgorithm[HKI_ENCRYPT_RIJNDAEL128]=GetDlgItem(IDC_RADIO_HKI_ENCRYPT1);
	Radio_EncryptAlgorithm[HKI_ENCRYPT_RIJNDAEL256]=GetDlgItem(IDC_RADIO_HKI_ENCRYPT2);
	Radio_EncryptAlgorithm[HKI_ENCRYPT_SINGLE_DES]=GetDlgItem(IDC_RADIO_HKI_ENCRYPT3);
	Radio_EncryptAlgorithm[HKI_ENCRYPT_TRIPLE_DES]=GetDlgItem(IDC_RADIO_HKI_ENCRYPT4);
	Radio_EncryptAlgorithm[HKI_ENCRYPT_BLOWFISH448]=GetDlgItem(IDC_RADIO_HKI_ENCRYPT5);
	Radio_EncryptAlgorithm[HKI_ENCRYPT_TWOFISH128]=GetDlgItem(IDC_RADIO_HKI_ENCRYPT6);
	Radio_EncryptAlgorithm[HKI_ENCRYPT_TWOFISH256]=GetDlgItem(IDC_RADIO_HKI_ENCRYPT7);
	Radio_EncryptAlgorithm[HKI_ENCRYPT_SQUARE]=GetDlgItem(IDC_RADIO_HKI_ENCRYPT8);

	Radio_EncryptAlgorithm[Config.HKI.EncryptAlgorithm].SetCheck(1);

	return TRUE;
}

LRESULT CConfigHKI::OnApply()
{
//===============================
// ݒConfigManagerɏ߂
//===============================
	//------------------
	// kx̑I
	//------------------
	for(int i=0;i<HKI_COMPRESS_LEVEL_MAX_NUM;i++){
		if(Radio_CompressLevel[i].GetCheck()){
			Config.HKI.CompressLevel=(HKI_COMPRESS_LEVEL)i;
			break;
		}
	}
	//--------------------------
	// ÍASY̑I
	//--------------------------
	for(int i=0;i<HKI_ENCRYPT_ALGORITHM_MAX_NUM;i++){
		if(Radio_EncryptAlgorithm[i].GetCheck()){
			Config.HKI.EncryptAlgorithm=(HKI_ENCRYPT_ALGORITHM)i;
			break;
		}
	}

	return TRUE;
}

