#pragma once
//#include "DataObject.h"
#include "../dirtree.h"
#include "../../ArchiverCode/arc_interface.h"
//Original code from http://hp.vector.co.jp/authors/VA016117/
//Modified by Claybird http://claybird.hp.infoseek.co.jp/

class CDropSource : public IDropSource
{
protected:
	LONG _RefCount;
	CString ArcFileName;
	std::list<CDirectoryTree*> &ItemList;
	CString OutputDir;
	CArchiverDLL *Archiver;
	CDirectoryTree *Base;
	CDirectoryTree *lpRoot;
	DWORD m_dwEffect;
public:
	CDropSource(std::list<CDirectoryTree*> &dl,LPCTSTR od,CArchiverDLL *a,LPCTSTR afn,CDirectoryTree *b)
		:_RefCount(1),ItemList(dl),OutputDir(od),Archiver(a),ArcFileName(afn),Base(b),m_dwEffect(0),m_bRet(false)
	{
		lpRoot=Base;
		while(lpRoot&&lpRoot->GetParent()){
			lpRoot=lpRoot->GetParent();
		}
	}
	virtual ~CDropSource(){};

	virtual HRESULT __stdcall QueryInterface(const IID& iid, void** ppv);
	virtual ULONG __stdcall AddRef(void);
	virtual ULONG __stdcall Release(void);

	virtual HRESULT __stdcall QueryContinueDrag(BOOL fEscapePressed, DWORD grfKeyState);
	virtual HRESULT __stdcall GiveFeedback(DWORD dwEffect);

	CString m_strLog;
	bool m_bRet;
};

